#!/usr/bin/perl -w

open( BREF, $ARGV[0] );
open( SPEC, $ARGV[1] );
open( BIB, $ARGV[2] );
open( DEF, ">$ARGV[3]" );

@bref = <BREF>;
close( BREF );

my @verse;
my @books;

while( $inspec = <SPEC> )
{
	chomp( $inspec );
	(my $book, my $translated) = split(/:/, $inspec);
	if ($book != 0)
	{
		my $x = 0;
		while ( !($bref[$x] =~ /^$book\:/) && defined( $bref[$x] ) ) { $x++; }
		chomp ($bref[$x]);
		$bref[$x] =~ s/\t(.)*$//g;
	
		while ( $bref[$x] =~ /^$book\:/ )
		{
			chomp ($bref[$x]);
			$bref[$x] =~ s/\t(.)*$//g;
			push( @verse, $bref[$x] );
			$x++;
		}
		push (@books, $translated);
	} else
	{
		push( @verse, $inspec );
	}
}


print "Titel:";
$titel = <STDIN>;
chomp($titel);

$titell = length($titel);
print DEF pack( "Csa*", 0x01, $titell, $titel );

my $thisbook = 0;
my $versei = 0;
my $ret = "";
my $pre = "";

my $currbook = 0;

foreach my $y (@verse)
{
	my $book = (split(/:/, $y))[0];
	if ($currbook == 0 && $book != 0) { $currbook = $book; } #Check here for problems with the OT later
	if ($book == 0)
	{
		my @vals = split(/:/, $y);
		$pre = pack( "Cssa*", 0x02, length($vals[2]), $vals[1], $vals[2] );
		if ($currbook == 0) { print DEF $pre; $pre = ""; }
		next;
	} else
	{
		if ($book != $currbook && $versei > 0)
		{
			print DEF pack( "Cssa*", 0x03, length( $books[$thisbook] ), $versei, $books[$thisbook] );
			print DEF $ret;
			if ( $pre ne "" )
			{
				print DEF $pre;
				$pre = "";
			}
			$versei = 0;
			$ret = "";
			$currbook = $book;
			$thisbook++;
		}
		$versei++;
		my @vals = split(/:/, $y);
		my $offset = tell( BIB );
		my $line = <BIB>;
		$ret .= pack("Cssis", 0x04, $vals[1], $vals[2], $offset, length($line));
	}
}

print DEF pack( "Cssa*", 0x03, length( $books[$thisbook] ), $versei, $books[$thisbook] );
print DEF $ret;

close(DEF);
close(BIB);
