/***************************************************************************
                          bbook.cpp  -  description
                             -------------------
    begin                : Son Aug 31 2003
    copyright            : (C) 2003 by David Weisgerber
    email                : tnt@md.2y.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bbook.h"
#include "new.h"

bbook::bbook()
{
  books = -1;
  this_testament = -1;
  bookcount = 0;
  totaltestaments = 0;
}
bbook::~bbook(){
}
/** No descriptions */
void bbook::settitle( char *m_title )
{
  title = m_title;  
}
/** No descriptions */
void bbook::i_settestament( char *testament )
{
  totaltestaments++;
  this_testament++;
  testaments[this_testament] = testament;
}

/** No descriptions */
void bbook::i_setbook( int verses, char *bookname )
{
  bookcount++;
  books++;
  sbooks[books] = new sbook( verses, bookname );
  tbooks[books] = this_testament;
}

/** No descriptions */
void bbook::addentry( int chapter, int vers, int offset, int length)
{
  if (books > -1)
  {
    sbooks[books]->add( chapter, vers, offset, length );
  }
}
/** No descriptions */
char * bbook::getbook()
{
  return sbooks[books]->gettitle();
}
/** No descriptions */
int bbook::gettext_o( int book, int chapter, int vers )
{
  return sbooks[book]->gettext_o( chapter, vers );
}
/** No descriptions */
int bbook::gettext_l( int book, int chapter, int vers )
{
  return sbooks[book]->gettext_l( chapter, vers );
}
/** No descriptions */
char * bbook::getbookname( int book )
{
  return sbooks[book]->gettitle();
}
/** No descriptions */
int bbook::getbooknum()
{
  return bookcount;
}
/** No descriptions */
int bbook::getchapter( int book )
{
  return sbooks[book]->getchapter();
}
/** No descriptions */
int bbook::getverses( int book, int chapter )
{
  return sbooks[book]->getverses( chapter );
}
/** No descriptions */
void bbook::next()
{
  if ( sbooks[books]->next() )
  {
    return;
  } else
  {
    if ( (books+1) < bookcount )
    {
      books++;
      sbooks[books]->setpos( 1, 1 );
    } else
    {
      books = 0;
      sbooks[books]->setpos( 1, 1 );
    }
  }
}
/** No descriptions */
void bbook::prev()
{
  if ( sbooks[books]->prev() )
  {
    return;
  } else
  {
    if ( books > 0 )
    {
      books--;
      sbooks[books]->setlast();
    } else
    {
      books = bookcount - 1;
      sbooks[books]->setlast();
    }
  } 
}
/** No descriptions */
bool bbook::setpos( int book, int chapter, int vers )
{
  if ( book <= bookcount )
  {
    books = book;
    return sbooks[books]->setpos( chapter, vers );
  } else
  {
    return false;
  }
}
/** No descriptions */
int bbook::chapter()
{
  return sbooks[books]->chapter();
}
/** No descriptions */
int bbook::vers()
{
  return sbooks[books]->vers();
}
/** No descriptions */
int bbook::offset()
{
  return sbooks[books]->offset();
}
/** No descriptions */
int bbook::length()
{
  return sbooks[books]->length();
}
/** No descriptions */
char *bbook::book()
{
  return sbooks[books]->gettitle();
}
/** No descriptions */
char * bbook::gettitle()
{
  return title;
}
/** No descriptions */
int bbook::getcurrent()
{
  return books;
}
/** No descriptions */
char * bbook::gettestament()
{
  return testaments[this_testament];
}

/** No descriptions */
int bbook::gettestamentnum()
{
  return totaltestaments;  
}
/** No descriptions */
char * bbook::gettestamentname( int num )
{
  return testaments[num];
}
/** No descriptions */
int bbook::getbooktestamentnum( int num )
{
  return tbooks[num];
}
/** No descriptions */
int bbook::gettstart( int num )
{
  int i = 0;
  while ( i < bookcount )
  {
    if ( num == tbooks[i] )
      break;
    i++;
  }
  if ( i == bookcount )
  {
    return 0;
  }
  return i;
}
