/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bible.h"
#include "appmain.h"
#include "new.h"
//#include "splash.h"



void GpMain(void *arg)               
{
  GPDRAWSURFACE gpDraw;
  //GP_HPALETTE old = GpRegPalGet();
  
  GpLcdSurfaceGet( &gpDraw, 0);
  /*GpPaletteSelect(GpPaletteCreate(256, splash_Pal));
  GpPaletteRealize();  */

  GpSurfaceSet( &gpDraw );

  //GpBitBlt(NULL, &gpDraw, 0, 0, gpDraw.buf_w, gpDraw.buf_h, (unsigned char*)splash, 0, 0, gpDraw.buf_w, gpDraw.buf_h );
  //GpPaletteSelect( old );
  //GpPaletteRealize();

  GpTextOut( NULL, &gpDraw, 100, 100, "Holy Bible v.01\nby David Weisgerber\n\nLoading...", 0xF0 );
  
  appmain *myApp = new appmain( gpDraw );
  myApp->exec();
}

void* operator new( long unsigned int size ){
	return ::gm_malloc(size);
}

void* operator new[]( long unsigned int size ){
	return ::gm_malloc(size);
}

void operator delete( void* todel ){
	::gm_free(todel);
}

void operator delete[]( void* todel ){
	::gm_free(todel);
}
