/***************************************************************************
                          combo.cpp  -  description
                             -------------------
    begin                : Die Sep 2 2003
    copyright            : (C) 2003 by David Weisgerber
    email                : tnt@md.2y.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "combo.h"

combo::combo(int m_x, int m_y)
{
  total = 0;
  is_selected = false;
  current = -1;
  x = m_x;
  y = m_y;
}
combo::~combo(){
}
/** No descriptions */
void combo::add( char *insert )
{
  current++;
  chars[current] = insert;
  total++;
}
/** No descriptions */
void combo::paint( GPDRAWSURFACE *surface )
{
  int i = 0;
  int vy = y;
  
  if ( is_selected )
  {
    if ( total > 4 )
    {
      GpRectFill( NULL, surface, x, y, x+180, y + 75, 0xFF ); // Well that's a bug but don't mind
      GpRectDraw( surface, x, y, x+180, y + 75, 0x00 );
      i = -2;
      while ( i < 3 )
      {
        int col = 0x00;
        if ( i == 0 ) col = 0xF0;
        GpTextOut( NULL, surface, x+1, vy, getitem( i ), col );
        i++;
        vy += 15;
      }
    } else
    {
      GpRectFill( NULL, surface, x, y, 180, (15*total), 0xFF ); // This API sucks
      GpRectDraw( surface, x, y, x+180, y + (15*total), 0x00 );
      i = 0;
      while ( i < total )
      {
        int col = 0x00;
        if ( i == current ) col = 0xF0;
        GpTextOut( NULL, surface, x+1, vy, getitem( i ), col );
        i++;
        vy += 15;
      }
    }
  } else
  {
    GpRectFill( NULL, surface, x, y, x + 180, y + 15, 0xFF );
    GpRectDraw( surface, x, y, x + 180, y + 15, 0x00 );
    GpTextOut( NULL, surface, x+1, y, chars[current], 0xF0 );
  }
}
/** No descriptions */
void combo::set( int what )
{
  current = what; //so what?
}
/** No descriptions */
char * combo::getitem( int item )
{
  if ( total > 4 )
  {
    if ( ( (current + item) >= 0 ) && ( ( current + item ) < total ) )
    {
      return chars[current+item];
    } else
    {
      if ( (current + item ) < 0 )
      {
        return chars[total+item+current];
      } else
      {
        return chars[item+current-total];
      }
    }
  } else
  {
    return chars[item];
  }
}
/** No descriptions */
void combo::setselected( bool selected )
{
  is_selected = selected;
}
/** No descriptions */
bool combo::active()
{
  return is_selected;
}
/** No descriptions */
void combo::next()
{
  if ( (current + 1) < total )
  {
    current++;
  } else
  {
    current = 0;
  }
}
/** No descriptions */
void combo::prev()
{
  if ( ( current - 1) >= 0 )
  {
    current--;
  } else
  {
    current = total - 1;
  }
}
/** No descriptions */
void combo::clear()
{
  current = -1;
  total = 0;
}
/** No descriptions */
void combo::clearfree()
{
  int i = 0;
  while ( i < total )
  {
    gp_mem_func.free( chars[i] );
    i++;
  }
  current = -1;
  total = 0;
}
/** No descriptions */
int combo::get()
{
  return current;
}
