/***************************************************************************
                          sbook.h  -  description
                             -------------------
    begin                : Son Aug 31 2003
    copyright            : (C) 2003 by David Weisgerber
    email                : tnt@md.2y.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SBOOK_H
#define SBOOK_H

#include "bible.h"

/**
  *@author David Weisgerber
  */
typedef struct b_entry
{
  int chapter;
  int vers;
  int offset;
  int length;
} b_entry;
  
class sbook {
public: 
	sbook(int, char*);
	~sbook();
  /** No descriptions */
  void add( int chapter, int vers, int offset, int length );
  /** No descriptions */
  char * gettitle();
  /** No descriptions */
  int gettext_o( int chapter, int vers );
  /** No descriptions */
  int gettext_l( int chapter, int vers );
  /** No descriptions */
  int getchapter();
  /** No descriptions */
  int getverses( int chapter );
  /** No descriptions */
  bool next();
  /** No descriptions */
  int length();
  /** No descriptions */
  int offset();
  /** No descriptions */
  bool setpos( int chapter, int vers );
  /** No descriptions */
  bool prev();
  /** No descriptions */
  int vers();
  /** No descriptions */
  int chapter();
  /** No descriptions */
  void setlast();

private:
  int verse;
  int pos;
  b_entry *entries;
  char *book;
};

#endif
