/***************************************************************************
                          sbook.cpp  -  description
                             -------------------
    begin                : Son Aug 31 2003
    copyright            : (C) 2003 by David Weisgerber
    email                : tnt@md.2y.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sbook.h"

sbook::sbook(int verses, char *title)
{
  entries = (b_entry*)gp_mem_func.malloc( sizeof(b_entry) * verses );
  verse = verses -1;
  book = title;
  pos = 0; 
}
sbook::~sbook(){
}
/** No descriptions */
void sbook::add( int chapter, int vers, int offset, int length )
{
  entries->chapter = chapter;
  entries->vers = vers;
  entries->offset = offset;
  entries->length = length;
  ++entries;
  pos++;  
}
/** No descriptions */
char * sbook::gettitle()
{
  return book;
}
/** No descriptions */
int sbook::gettext_o( int chapter, int vers )
{
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }

  while ( pos < verse )
  {
    if ( entries->chapter == chapter && entries->vers == vers )
    {
      return entries->offset;
    }

    ++entries;
    pos++;
  }

  return 0;    
}
/** No descriptions */
int sbook::gettext_l( int chapter, int vers )
{
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }

  while ( pos < verse )
  {
    if ( entries->chapter == chapter && entries->vers == vers )
    {
      return entries->length;
    }

    ++entries;
    pos++;
  }

  return 0;  
}
/** No descriptions */
int sbook::getchapter()
{
  int oldpos = pos;
  int retval;
  
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }
  
  while ( pos < verse )
  {
    ++entries;
    pos++;
  }

  retval = entries->chapter;
  
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }
  while ( pos != oldpos )
  {
    ++entries;
    pos++;
  }
  
  return retval;
}
/** No descriptions */
int sbook::getverses( int chapter )
{
  int retval;
  int oldpos = pos;

  while ( pos != 0 )
  {
    --entries;
    pos--;
  }
  while ( pos <= verse )
  {
    if ( entries->chapter == chapter )
    {
      retval = entries->vers;
    }
    ++entries;
    pos++;
  }

  while ( pos != 0 )
  {
    --entries;
    pos--;
  }
  while ( pos != oldpos )
  {
    ++entries;
    pos++;
  }

  return retval; 
}
/** No descriptions */
bool sbook::next()
{
  if ( pos < verse )
  {
    ++entries;
    pos++;
    return true;
  } else
  {
    return false;
  } 
}
/** No descriptions */
bool sbook::prev()
{
  if ( pos > 0 )
  {
    --entries;
    pos--;
    return true;
  } else
  {
    return false;
  }
}
/** No descriptions */
bool sbook::setpos( int chapter, int vers )
{
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }

  while ( pos < verse )
  {
    if ( entries->chapter == chapter && entries->vers == vers )
    {
      return true;
    }

    ++entries;
    pos++;
  }

  return false;  
}
/** No descriptions */
int sbook::offset()
{
  return entries->offset;
}
/** No descriptions */
int sbook::length()
{
  return entries->length;
}
/** No descriptions */
int sbook::chapter()
{
  return entries->chapter;
}
/** No descriptions */
int sbook::vers()
{
  return entries->vers;
}
/** No descriptions */
void sbook::setlast()
{
  while ( pos != 0 )
  {
    --entries;
    pos--;
  }

  while ( pos < verse )
  {
    ++entries;
    pos++;
  }
}
